program MergeSort;

const
   n   = 20;
   max = 977;
type
   table = array[1..n] of integer;
var
   tab	: table;
   half	: integer;
   i	: integer;
   v	: integer;

{
merge(i,n1,n2) merges tab[i..(i+n1-1)] and tab[(i+n1)..(i+n1+n2-1)]
supposed sorted.
}
procedure merge (i : integer; n1 : integer; n2 : integer);
var
   i1, i2, c : integer;
   temp	     : table;
begin

   i1 := i;
   i2 := i + n1;
   c := 1;

   while c <= n1 + n2 and i1 < i + n1 and i2 < i + n1 + n2 do
      if tab[i1] > tab[i2] then
      begin
	 temp[c] := tab[i2];
	 i2 := i2 + 1;
	 c := c + 1;
      end
      else
      begin
	 temp[c] := tab[i1];
	 i1 := i1 + 1;
	 c := c + 1;
      end;

   if i1 = i + n1 then
      while c <= n1 + n2 do
      begin
	 temp[c] := tab[i2];
	 i2 := i2 + 1;
	 c := c + 1;
      end;

   if i2 = i + n1 + n2 then
      while c <= n1 + n2 do
      begin
	 temp[c] := tab[i1];
	 i1 := i1 + 1;
	 c := c + 1;
      end;

   c := 0;
   while c < n1 + n2 do
   begin
      tab[c + i] := temp[c + 1];
      c := c + 1;
   end
end; { merge }


{ We assume that i < j }

procedure getHalf(i : integer ; j : integer);
var
   c1, c2 : integer;
begin
   c1 := i;
   c2 := i;
   while c2 < j do
   begin
      c1 := c1 + 1;
      c2 := c2 + 2;
   end;
   half := c1;
end; { getHalf }

procedure sort(i : integer;  j : integer);
var halfcopy : integer;
begin
   if i <> j then
   begin
      getHalf(i, j);
      halfcopy := half;
      sort(i, halfcopy - 1);
      sort(halfcopy, j);
      merge(i, halfcopy - i, j - halfcopy + 1);
   end
end; { sort }

procedure printTab;
var i : integer;
begin
   i := 1;
   while i <= n do
   begin
      writeInt(tab[i]);
      i := i + 1;
   end;
end; { printTab }

begin
   v := 109;
   i := 1;
   while i <= n do
   begin
      v := (v * v + i) mod max; { stupid rand }
      tab[i] := v;
      i := i + 1;
   end;

   printTab;
   writeBool(true);
   sort(1, n);
   printTab;
end.