(*
  Bifton - A Pascal- compiler.

  Copyright (C) 2004 Samuel Mimram & Julien Cristau.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(* $Id: log.mli,v 1.1 2004/03/02 14:39:00 uid20001 Exp $ *)

(**
  Informations, warnings and errors logging.

  @author Samuel Mimram, Julien Cristau
*)

(** Print an information message. *)
val information : string -> unit 

(** Print a warning message. *)
val warning : string -> unit

(** Print an error message. *)
val error : string -> unit

(** Print a debug message. *)
val debug : string -> unit
