program BubbleSort;

const
   n   = 20;
   max = 666;
type
   table = array[1..n] of integer;
var
   tab	: table;
   half	: integer;
   i	: integer;
   v	: integer;

procedure printTab;
var
   i : integer;
begin
   i := 1;
   while i <= n do
   begin
      writeInt(tab[i]);
      i := i + 1;
   end;
end; { printTab }

procedure swap(i, j : integer);
var tmp	: integer;
begin
   tmp := tab[i];
   tab[i] := tab[j];
   tab[j] := tmp
end; { swap }


procedure sort(max : integer);
var
   i, j : integer;
begin
   i := 1;
   while i < n do
   begin
      if tab[i] > tab[i + 1] then
	 swap(i, i + 1);
      i := i + 1;
   end
end; { sort }

begin
   v := 109;
   i := 1;
   while i <= n do
   begin
      v := (v * v + i) mod max; { stupid rand }
      tab[i] := v;
      i := i + 1;
   end;

   printTab;
   writeBool(true);

   i := n;
   while i > 0 do
   begin
      i := i - 1;
      sort(i)
   end;

   printTab
end.
